diff --git a/gcc/analyzer/program-state.cc b/gcc/analyzer/program-state.cc
index 1a5843be16d..c92988156b9 100644
--- a/gcc/analyzer/program-state.cc
+++ b/gcc/analyzer/program-state.cc
@@ -33,13 +33,15 @@ along with GCC; see the file COPYING3.  If not see
 #include "tristate.h"
 #include "ordered-hash-map.h"
 #include "selftest.h"
+#include "analyzer/call-string.h"
+#include "analyzer/program-point.h"
+#include "analyzer/store.h"
 #include "analyzer/region-model.h"
 #include "analyzer/program-state.h"
 #include "analyzer/constraint-manager.h"
 #include "alloc-pool.h"
 #include "fibonacci_heap.h"
 #include "shortest-paths.h"
-#include "analyzer/constraint-manager.h"
 #include "diagnostic-event-id.h"
 #include "analyzer/pending-diagnostic.h"
 #include "analyzer/diagnostic-manager.h"
@@ -50,8 +52,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "cgraph.h"
 #include "digraph.h"
 #include "analyzer/supergraph.h"
-#include "analyzer/call-string.h"
-#include "analyzer/program-point.h"
 #include "analyzer/program-state.h"
 #include "analyzer/exploded-graph.h"
 #include "analyzer/state-purge.h"
@@ -99,12 +99,23 @@ extrinsic_state::dump () const
   dump_to_file (stderr);
 }
 
+/* Get the region_model_manager for this extrinsic_state.  */
+
+region_model_manager *
+extrinsic_state::get_model_manager () const
+{
+  if (m_engine)
+    return m_engine->get_model_manager ();
+  else
+    return NULL; /* for selftests.  */
+}
+
 /* class sm_state_map.  */
 
 /* sm_state_map's ctor.  */
 
-sm_state_map::sm_state_map ()
-: m_map (), m_global_state (0)
+sm_state_map::sm_state_map (const state_machine &sm, int sm_idx)
+: m_sm (sm), m_sm_idx (sm_idx), m_map (), m_global_state (0)
 {
 }
 
@@ -116,77 +127,56 @@ sm_state_map::clone () const
   return new sm_state_map (*this);
 }
 
-/* Clone this sm_state_map, remapping all svalue_ids within it with ID_MAP.
-
-   Return NULL if there are any svalue_ids that have sm-state for which
-   ID_MAP maps them to svalue_id::null (and thus the clone would have lost
-   the sm-state information). */
-
-sm_state_map *
-sm_state_map::clone_with_remapping (const one_way_svalue_id_map &id_map) const
-{
-  sm_state_map *result = new sm_state_map ();
-  result->m_global_state = m_global_state;
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      svalue_id sid = (*iter).first;
-      gcc_assert (!sid.null_p ());
-      entry_t e = (*iter).second;
-      /* TODO: what should we do if the origin maps from non-null to null?
-	 Is that loss of information acceptable?  */
-      id_map.update (&e.m_origin);
-
-      svalue_id new_sid = id_map.get_dst_for_src (sid);
-      if (new_sid.null_p ())
-	{
-	  delete result;
-	  return NULL;
-	}
-      result->m_map.put (new_sid, e);
-    }
-  return result;
-}
-
-/* Print this sm_state_map (for SM) to PP.
+/* Print this sm_state_map to PP.
    If MODEL is non-NULL, print representative tree values where
    available.  */
 
 void
-sm_state_map::print (const state_machine &sm, const region_model *model,
-		     pretty_printer *pp) const
+sm_state_map::print (const region_model *model,
+		      bool simple, bool multiline,
+		      pretty_printer *pp) const
 {
   bool first = true;
-  pp_string (pp, "{");
+  if (!multiline)
+    pp_string (pp, "{");
   if (m_global_state != 0)
     {
-      pp_printf (pp, "global: %s", sm.get_state_name (m_global_state));
+      if (multiline)
+	pp_string (pp, "  ");
+      pp_printf (pp, "global: %s", m_sm.get_state_name (m_global_state));
+      if (multiline)
+	pp_newline (pp);
       first = false;
     }
   for (map_t::iterator iter = m_map.begin ();
        iter != m_map.end ();
        ++iter)
     {
-      if (!first)
+      if (multiline)
+	pp_string (pp, "  ");
+      else if (!first)
 	pp_string (pp, ", ");
       first = false;
-      svalue_id sid = (*iter).first;
-      sid.print (pp);
+      const svalue *sval = (*iter).first;
+      pp_pointer (pp, sval);
+      pp_string (pp, ": ");
+      sval->dump_to_pp (pp, simple);
 
       entry_t e = (*iter).second;
-      pp_printf (pp, ": %s", sm.get_state_name (e.m_state));
+      pp_printf (pp, ": %s", m_sm.get_state_name (e.m_state));
       if (model)
-	if (tree rep = model->get_representative_tree (sid))
+	if (tree rep = model->get_representative_tree (sval))
 	  {
 	    pp_string (pp, " (");
 	    dump_quoted_tree (pp, rep);
 	    pp_character (pp, ')');
 	  }
-      if (!e.m_origin.null_p ())
+      if (e.m_origin)
 	{
 	  pp_string (pp, " (origin: ");
-	  e.m_origin.print (pp);
+	  pp_pointer (pp, e.m_origin);
+	  pp_string (pp, ": ");
+	  e.m_origin->dump_to_pp (pp, simple);
 	  if (model)
 	    if (tree rep = model->get_representative_tree (e.m_origin))
 	      {
@@ -196,19 +186,22 @@ sm_state_map::print (const state_machine &sm, const region_model *model,
 	      }
 	  pp_string (pp, ")");
 	}
+      if (multiline)
+	pp_newline (pp);
     }
-  pp_string (pp, "}");
+  if (!multiline)
+    pp_string (pp, "}");
 }
 
-/* Dump this object (for SM) to stderr.  */
+/* Dump this object to stderr.  */
 
 DEBUG_FUNCTION void
-sm_state_map::dump (const state_machine &sm) const
+sm_state_map::dump (bool simple) const
 {
   pretty_printer pp;
   pp_show_color (&pp) = pp_show_color (global_dc->printer);
   pp.buffer->stream = stderr;
-  print (sm, NULL, &pp);
+  print (NULL, simple, true, &pp);
   pp_newline (&pp);
   pp_flush (&pp);
 }
@@ -237,10 +230,10 @@ sm_state_map::hash () const
        ++iter)
     {
       inchash::hash hstate;
-      inchash::add ((*iter).first, hstate);
+      hstate.add_ptr ((*iter).first);
       entry_t e = (*iter).second;
       hstate.add_int (e.m_state);
-      inchash::add (e.m_origin, hstate);
+      hstate.add_ptr (e.m_origin);
       result ^= hstate.end ();
     }
   result ^= m_global_state;
@@ -263,9 +256,9 @@ sm_state_map::operator== (const sm_state_map &other) const
        iter != m_map.end ();
        ++iter)
     {
-      svalue_id sid = (*iter).first;
+      const svalue *sval = (*iter).first;
       entry_t e = (*iter).second;
-      entry_t *other_slot = const_cast <map_t &> (other.m_map).get (sid);
+      entry_t *other_slot = const_cast <map_t &> (other.m_map).get (sval);
       if (other_slot == NULL)
 	return false;
       if (e != *other_slot)
@@ -277,34 +270,63 @@ sm_state_map::operator== (const sm_state_map &other) const
   return true;
 }
 
-/* Get the state of SID within this object.
+/* Get the state of SVAL within this object.
    States default to the start state.  */
 
 state_machine::state_t
-sm_state_map::get_state (svalue_id sid) const
+sm_state_map::get_state (const svalue *sval,
+			  const extrinsic_state &ext_state) const
 {
-  gcc_assert (!sid.null_p ());
+  gcc_assert (sval);
+
+  sval = canonicalize_svalue (sval, ext_state);
 
   if (entry_t *slot
-      = const_cast <map_t &> (m_map).get (sid))
+      = const_cast <map_t &> (m_map).get (sval))
     return slot->m_state;
-  else
-    return 0;
+
+  /* SVAL has no explicit sm-state.
+     If this sm allows for state inheritance, then SVAL might have implicit
+     sm-state inherited via a parent.
+     For example INIT_VAL(foo.field) might inherit taintedness state from
+     INIT_VAL(foo).  */
+  if (m_sm.inherited_state_p ())
+    if (region_model_manager *mgr = ext_state.get_model_manager ())
+      if (const initial_svalue *init_sval = sval->dyn_cast_initial_svalue ())
+	{
+	  const region *reg = init_sval->get_region ();
+	  /* Try recursing upwards (up to the base region for the cluster).  */
+	  if (!reg->base_region_p ())
+	    if (const region *parent_reg = reg->get_parent_region ())
+	      {
+		const svalue *parent_init_sval
+		  = mgr->get_or_create_initial_value (parent_reg);
+		state_machine::state_t parent_state
+		  = get_state (parent_init_sval, ext_state);
+		if (parent_state)
+		  return parent_state;
+	      }
+	}
+
+  return m_sm.get_default_state (sval);
 }
 
-/* Get the "origin" svalue_id for any state of SID.  */
+/* Get the "origin" svalue for any state of SVAL.  */
 
-svalue_id
-sm_state_map::get_origin (svalue_id sid) const
+const svalue *
+sm_state_map::get_origin (const svalue *sval,
+			   const extrinsic_state &ext_state) const
 {
-  gcc_assert (!sid.null_p ());
+  gcc_assert (sval);
+
+  sval = canonicalize_svalue (sval, ext_state);
 
   entry_t *slot
-    = const_cast <map_t &> (m_map).get (sid);
+    = const_cast <map_t &> (m_map).get (sval);
   if (slot)
     return slot->m_origin;
   else
-    return svalue_id::null ();
+    return NULL;
 }
 
 /* Set the state of SID within MODEL to STATE, recording that
@@ -312,28 +334,21 @@ sm_state_map::get_origin (svalue_id sid) const
 
 void
 sm_state_map::set_state (region_model *model,
-			 svalue_id sid,
+			 const svalue *sval,
 			 state_machine::state_t state,
-			 svalue_id origin)
+			 const svalue *origin,
+			 const extrinsic_state &ext_state)
 {
   if (model == NULL)
     return;
-  equiv_class &ec = model->get_constraints ()->get_equiv_class (sid);
-  if (!set_state (ec, state, origin))
-    return;
 
-  /* Also do it for all svalues that are equal via non-cm, so that
-     e.g. (void *)&r and (foo *)&r transition together.  */
-  for (unsigned i = 0; i < model->get_num_svalues (); i++)
-    {
-      svalue_id other_sid = svalue_id::from_int (i);
-      if (other_sid == sid)
-	continue;
+  /* Reject attempts to set state on UNKNOWN.  */
+  if (sval->get_kind () == SK_UNKNOWN)
+    return;
 
-      tristate eq = model->eval_condition_without_cm (sid, EQ_EXPR, other_sid);
-      if (eq.is_true ())
-	impl_set_state (other_sid, state, origin);
-    }
+  equiv_class &ec = model->get_constraints ()->get_equiv_class (sval);
+  if (!set_state (ec, state, origin, ext_state))
+    return;
 }
 
 /* Set the state of EC to STATE, recording that the state came from
@@ -343,35 +358,40 @@ sm_state_map::set_state (region_model *model,
 bool
 sm_state_map::set_state (const equiv_class &ec,
 			 state_machine::state_t state,
-			 svalue_id origin)
+			 const svalue *origin,
+			 const extrinsic_state &ext_state)
 {
   int i;
-  svalue_id *sid;
+  const svalue *sval;
   bool any_changed = false;
-  FOR_EACH_VEC_ELT (ec.m_vars, i, sid)
-    any_changed |= impl_set_state (*sid, state, origin);
+  FOR_EACH_VEC_ELT (ec.m_vars, i, sval)
+    any_changed |= impl_set_state (sval, state, origin, ext_state);
   return any_changed;
 }
 
-/* Set state of SID to STATE, bypassing equivalence classes.
+/* Set state of SVAL to STATE, bypassing equivalence classes.
    Return true if the state changed.  */
 
 bool
-sm_state_map::impl_set_state (svalue_id sid, state_machine::state_t state,
-			      svalue_id origin)
+sm_state_map::impl_set_state (const svalue *sval,
+			      state_machine::state_t state,
+			      const svalue *origin,
+			      const extrinsic_state &ext_state)
 {
-  if (get_state (sid) == state)
+  sval = canonicalize_svalue (sval, ext_state);
+
+  if (get_state (sval, ext_state) == state)
     return false;
 
   /* Special-case state 0 as the default value.  */
   if (state == 0)
     {
-      if (m_map.get (sid))
-	m_map.remove (sid);
+      if (m_map.get (sval))
+	m_map.remove (sval);
       return true;
     }
-  gcc_assert (!sid.null_p ());
-  m_map.put (sid, entry_t (state, origin));
+  gcc_assert (sval);
+  m_map.put (sval, entry_t (state, origin));
   return true;
 }
 
@@ -391,203 +411,105 @@ sm_state_map::get_global_state () const
   return m_global_state;
 }
 
-/* Handle CALL to unknown FNDECL with an unknown function body, which
-   could do anything to the states passed to it.
-   Clear any state for SM for the params and any LHS.
-   Note that the function might be known to other state machines, but
-   not to this one.  */
+/* Purge any state for SVAL.
+   If !SM::can_purge_p, then report the state as leaking,
+   using CTXT.  */
 
 void
-sm_state_map::purge_for_unknown_fncall (const exploded_graph &eg,
-					const state_machine &sm,
-					const gcall *call,
-					tree fndecl,
-					region_model *new_model,
-					region_model_context *ctxt)
+sm_state_map::on_svalue_leak (const svalue *sval,
+			      impl_region_model_context *ctxt)
 {
-  logger * const logger = eg.get_logger ();
-  if (logger)
+  if (state_machine::state_t state = get_state (sval, ctxt->m_ext_state))
     {
-      if (fndecl)
-	logger->log ("function %qE is unknown to checker %qs",
-		     fndecl, sm.get_name ());
-      else
-	logger->log ("unknown function pointer for checker %qs",
-		     sm.get_name ());
-    }
-
-  /* Purge any state for parms.  */
-  tree iter_param_types = NULL_TREE;
-  if (fndecl)
-    iter_param_types = TYPE_ARG_TYPES (TREE_TYPE (fndecl));
-  for (unsigned arg_idx = 0; arg_idx < gimple_call_num_args (call); arg_idx++)
-    {
-      /* Track expected param type, where available.  */
-      if (iter_param_types)
-	{
-	  tree param_type = TREE_VALUE (iter_param_types);
-	  gcc_assert (param_type);
-	  iter_param_types = TREE_CHAIN (iter_param_types);
-
-	  /* Don't purge state if it was passed as a const pointer
-	     e.g. for things like strlen (PTR).  */
-	  if (TREE_CODE (param_type) == POINTER_TYPE)
-	    if (TYPE_READONLY (TREE_TYPE (param_type)))
-	      continue;
-	}
-      tree parm = gimple_call_arg (call, arg_idx);
-      svalue_id parm_sid = new_model->get_rvalue (parm, ctxt);
-      set_state (new_model, parm_sid, 0, svalue_id::null ());
-
-      /* Also clear sm-state from svalue_ids that are passed via a
-	 pointer.  */
-      if (TREE_CODE (parm) == ADDR_EXPR)
-	{
-	  tree pointee = TREE_OPERAND (parm, 0);
-	  svalue_id parm_sid = new_model->get_rvalue (pointee, ctxt);
-	  set_state (new_model, parm_sid, 0, svalue_id::null ());
-	}
-    }
-
-  /* Purge any state for any LHS.  */
-  if (tree lhs = gimple_call_lhs (call))
-    {
-      svalue_id lhs_sid = new_model->get_rvalue (lhs, ctxt);
-      set_state (new_model, lhs_sid, 0, svalue_id::null ());
+      if (!m_sm.can_purge_p (state))
+	ctxt->on_state_leak (m_sm, sval, state);
+      m_map.remove (sval);
     }
 }
 
-/* Update this map based on MAP.  */
+/* Purge any state for svalues that aren't live with respect to LIVE_SVALUES
+   and MODEL.  */
 
 void
-sm_state_map::remap_svalue_ids (const svalue_id_map &map)
+sm_state_map::on_liveness_change (const svalue_set &live_svalues,
+				  const region_model *model,
+				  impl_region_model_context *ctxt)
 {
-  map_t tmp_map;
+  svalue_set svals_to_unset;
 
-  /* Build an intermediate map, using the new sids.  */
   for (map_t::iterator iter = m_map.begin ();
        iter != m_map.end ();
        ++iter)
     {
-      svalue_id sid = (*iter).first;
-      entry_t e = (*iter).second;
-
-      map.update (&sid);
-      map.update (&e.m_origin);
-      tmp_map.put (sid, e);
-    }
-
-  /* Clear the existing values.  */
-  m_map.empty ();
-
-  /* Copy over from intermediate map.  */
-  for (map_t::iterator iter = tmp_map.begin ();
-       iter != tmp_map.end ();
-       ++iter)
-    {
-      svalue_id sid = (*iter).first;
-      entry_t e = (*iter).second;
-
-      impl_set_state (sid, e.m_state, e.m_origin);
-    }
-}
-
-/* Purge any state for svalue_ids >= FIRST_UNUSED_SID.
-   If !SM::can_purge_p, then report the state as leaking,
-   using SM_IDX, CTXT, and MAP.
-   Return the number of states that were purged.  */
-
-int
-sm_state_map::on_svalue_purge (const state_machine &sm,
-			       int sm_idx,
-			       svalue_id first_unused_sid,
-			       const svalue_id_map &map,
-			       impl_region_model_context *ctxt)
-{
-  /* TODO: ideally remove the slot directly; for now
-     do it in two stages.  */
-  auto_vec<svalue_id> to_remove;
-  for (map_t::iterator iter = m_map.begin ();
-       iter != m_map.end ();
-       ++iter)
-    {
-      svalue_id dst_sid ((*iter).first);
-      if (dst_sid.as_int () >= first_unused_sid.as_int ())
+      const svalue *iter_sval = (*iter).first;
+      if (!iter_sval->live_p (live_svalues, model))
 	{
-	  /* Complain about leaks here.  */
+	  svals_to_unset.add (iter_sval);
 	  entry_t e = (*iter).second;
-
-	  if (!sm.can_purge_p (e.m_state))
-	    ctxt->on_state_leak (sm, sm_idx, dst_sid, first_unused_sid,
-				 map, e.m_state);
-
-	  to_remove.safe_push (dst_sid);
-	}
-      else if ((*iter).second.m_origin.as_int () >= first_unused_sid.as_int ())
-	{
-	  /* If the origin svalue is being purged, then reset it to null.  */
-	  (*iter).second.m_origin = svalue_id::null ();
+	  if (!m_sm.can_purge_p (e.m_state))
+	    ctxt->on_state_leak (m_sm, iter_sval, e.m_state);
 	}
     }
 
-  int i;
-  svalue_id *dst_sid;
-  FOR_EACH_VEC_ELT (to_remove, i, dst_sid)
-    m_map.remove (*dst_sid);
-
-  return to_remove.length ();
+  for (svalue_set::iterator iter = svals_to_unset.begin ();
+       iter != svals_to_unset.end (); ++iter)
+    m_map.remove (*iter);
 }
 
-/* Set the state of CHILD_SID to that of PARENT_SID.  */
+/* Purge state from SVAL (in response to a call to an unknown function).  */
 
 void
-sm_state_map::on_inherited_svalue (svalue_id parent_sid,
-				   svalue_id child_sid)
+sm_state_map::on_unknown_change (const svalue *sval,
+				 bool is_mutable,
+				 const extrinsic_state &ext_state)
 {
-  state_machine::state_t state = get_state (parent_sid);
-  impl_set_state (child_sid, state, parent_sid);
-}
-
-/* Set the state of DST_SID to that of SRC_SID.  */
-
-void
-sm_state_map::on_cast (svalue_id src_sid,
-		       svalue_id dst_sid)
-{
-  state_machine::state_t state = get_state (src_sid);
-  impl_set_state (dst_sid, state, get_origin (src_sid));
-}
-
-/* Purge state from SID (in response to a call to an unknown function).  */
-
-void
-sm_state_map::on_unknown_change (svalue_id sid)
-{
-  impl_set_state (sid, (state_machine::state_t)0, svalue_id::null ());
-}
-
-/* Assert that this object is sane.  */
-
-void
-sm_state_map::validate (const state_machine &sm,
-			int num_svalues) const
-{
-  /* Skip this in a release build.  */
-#if !CHECKING_P
-  return;
-#endif
+  svalue_set svals_to_unset;
 
   for (map_t::iterator iter = m_map.begin ();
        iter != m_map.end ();
        ++iter)
     {
-      svalue_id sid = (*iter).first;
+      const svalue *key = (*iter).first;
       entry_t e = (*iter).second;
-
-      gcc_assert (sid.as_int () < num_svalues);
-      sm.validate (e.m_state);
-      gcc_assert (e.m_origin.as_int () < num_svalues);
+      /* We only want to purge state for some states when things
+	 are mutable.  For example, in sm-malloc.cc, an on-stack ptr
+	 doesn't stop being stack-allocated when passed to an unknown fn.  */
+      if (!m_sm.reset_when_passed_to_unknown_fn_p (e.m_state, is_mutable))
+	continue;
+      if (key == sval)
+	svals_to_unset.add (key);
+      /* If we have INIT_VAL(BASE_REG), then unset any INIT_VAL(REG)
+	 for REG within BASE_REG.  */
+      if (const initial_svalue *init_sval = sval->dyn_cast_initial_svalue ())
+	if (const initial_svalue *init_key = key->dyn_cast_initial_svalue ())
+	  {
+	    const region *changed_reg = init_sval->get_region ();
+	    const region *changed_key = init_key->get_region ();
+	    if (changed_key->get_base_region () == changed_reg)
+	      svals_to_unset.add (key);
+	  }
     }
+
+  for (svalue_set::iterator iter = svals_to_unset.begin ();
+       iter != svals_to_unset.end (); ++iter)
+    impl_set_state (*iter, (state_machine::state_t)0, NULL, ext_state);
+}
+
+/* Canonicalize SVAL before getting/setting it within the map.
+   Convert all NULL pointers to (void *) to avoid state explosions
+   involving all of the various (foo *)NULL vs (bar *)NULL.  */
+
+const svalue *
+sm_state_map::canonicalize_svalue (const svalue *sval,
+				   const extrinsic_state &ext_state)
+{
+  region_model_manager *mgr = ext_state.get_model_manager ();
+  if (mgr && sval->get_type () && POINTER_TYPE_P (sval->get_type ()))
+    if (tree cst = sval->maybe_get_constant ())
+      if (zerop (cst))
+	return mgr->get_or_create_constant_svalue (null_pointer_node);
+
+  return sval;
 }
 
 /* class program_state.  */
@@ -595,13 +517,19 @@ sm_state_map::validate (const state_machine &sm,
 /* program_state's ctor.  */
 
 program_state::program_state (const extrinsic_state &ext_state)
-: m_region_model (new region_model ()),
+: m_region_model (NULL),
   m_checker_states (ext_state.get_num_checkers ()),
   m_valid (true)
 {
-  int num_states = ext_state.get_num_checkers ();
+  engine *eng = ext_state.get_engine ();
+  region_model_manager *mgr = eng->get_model_manager ();
+  m_region_model = new region_model (mgr);
+  const int num_states = ext_state.get_num_checkers ();
   for (int i = 0; i < num_states; i++)
-    m_checker_states.quick_push (new sm_state_map ());
+    {
+      sm_state_map *sm = new sm_state_map (ext_state.get_sm (i), i);
+      m_checker_states.quick_push (sm);
+    }
 }
 
 /* program_state's copy ctor.  */
@@ -708,7 +636,7 @@ program_state::print (const extrinsic_state &ext_state,
 		      pretty_printer *pp) const
 {
   pp_printf (pp, "rmodel: ");
-  m_region_model->print (pp);
+  m_region_model->dump_to_pp (pp, true, false);
   pp_newline (pp);
 
   int i;
@@ -718,7 +646,7 @@ program_state::print (const extrinsic_state &ext_state,
       if (!smap->is_empty_p ())
 	{
 	  pp_printf (pp, "%s: ", ext_state.get_name (i));
-	  smap->print (ext_state.get_sm (i), m_region_model, pp);
+	  smap->print (m_region_model, true, false, pp);
 	  pp_newline (pp);
 	}
     }
@@ -729,17 +657,25 @@ program_state::print (const extrinsic_state &ext_state,
     }
 }
 
-/* Dump a representation of this state to PP.
-   If SUMMARIZE is true, print a one-line summary;
-   if false, print a detailed multiline representation.  */
+/* Dump a representation of this state to PP.  */
 
 void
 program_state::dump_to_pp (const extrinsic_state &ext_state,
-			   bool summarize,
+			   bool /*summarize*/, bool multiline,
 			   pretty_printer *pp) const
 {
-  pp_printf (pp, "rmodel: ");
-  m_region_model->dump_to_pp (pp, summarize);
+  if (!multiline)
+    pp_string (pp, "{");
+  {
+    pp_printf (pp, "rmodel:");
+    if (multiline)
+      pp_newline (pp);
+    else
+      pp_string (pp, " {");
+    m_region_model->dump_to_pp (pp, true, multiline);
+    if (!multiline)
+      pp_string (pp, "}");
+  }
 
   int i;
   sm_state_map *smap;
@@ -747,30 +683,34 @@ program_state::dump_to_pp (const extrinsic_state &ext_state,
     {
       if (!smap->is_empty_p ())
 	{
-	  if (summarize)
-	    pp_space (pp);
+	  if (!multiline)
+	    pp_string (pp, " {");
 	  pp_printf (pp, "%s: ", ext_state.get_name (i));
-	  smap->print (ext_state.get_sm (i), m_region_model, pp);
-	  if (!summarize)
+	  if (multiline)
 	    pp_newline (pp);
+	  smap->print (m_region_model, true, multiline, pp);
+	  if (!multiline)
+	    pp_string (pp, "}");
 	}
     }
 
   if (!m_valid)
     {
-      if (summarize)
+      if (!multiline)
 	pp_space (pp);
       pp_printf (pp, "invalid state");
-      if (!summarize)
+      if (multiline)
 	pp_newline (pp);
     }
+  if (!multiline)
+    pp_string (pp, "}");
 }
 
-/* Dump a multiline representation of this state to OUTF.  */
+/* Dump a representation of this state to OUTF.  */
 
 void
 program_state::dump_to_file (const extrinsic_state &ext_state,
-			     bool summarize,
+			     bool summarize, bool multiline,
 			     FILE *outf) const
 {
   pretty_printer pp;
@@ -778,7 +718,7 @@ program_state::dump_to_file (const extrinsic_state &ext_state,
   if (outf == stderr)
     pp_show_color (&pp) = pp_show_color (global_dc->printer);
   pp.buffer->stream = outf;
-  dump_to_pp (ext_state, summarize, &pp);
+  dump_to_pp (ext_state, summarize, multiline, &pp);
   pp_flush (&pp);
 }
 
@@ -788,7 +728,25 @@ DEBUG_FUNCTION void
 program_state::dump (const extrinsic_state &ext_state,
 		     bool summarize) const
 {
-  dump_to_file (ext_state, summarize, stderr);
+  dump_to_file (ext_state, summarize, true, stderr);
+}
+
+/* Update this program_state to reflect a top-level call to FUN.
+   The params will have initial_svalues.  */
+
+void
+program_state::push_frame (const extrinsic_state &ext_state ATTRIBUTE_UNUSED,
+			   function *fun)
+{
+  m_region_model->push_frame (fun, NULL, NULL);
+}
+
+/* Get the current function of this state.  */
+
+function *
+program_state::get_current_function () const
+{
+  return m_region_model->get_current_function ();
 }
 
 /* Determine if following edge SUCC from ENODE is valid within the graph EG
@@ -806,8 +764,7 @@ program_state::dump (const extrinsic_state &ext_state,
 bool
 program_state::on_edge (exploded_graph &eg,
 			const exploded_node &enode,
-			const superedge *succ,
-			state_change *change)
+			const superedge *succ)
 {
   /* Update state.  */
   const program_point &point = enode.get_point ();
@@ -824,7 +781,7 @@ program_state::on_edge (exploded_graph &eg,
 
   impl_region_model_context ctxt (eg, &enode,
 				  &enode.get_state (),
-				  this, change,
+				  this,
 				  last_stmt);
   if (!m_region_model->maybe_update_for_edge (*succ,
 					      last_stmt,
@@ -838,6 +795,10 @@ program_state::on_edge (exploded_graph &eg,
       return false;
     }
 
+  program_state::detect_leaks (enode.get_state (), *this,
+				NULL, eg.get_ext_state (),
+				&ctxt);
+
   return true;
 }
 
@@ -845,15 +806,12 @@ program_state::on_edge (exploded_graph &eg,
    relevant at POINT.
    The idea is that we're more likely to be able to consolidate
    multiple (point, state) into single exploded_nodes if we discard
-   irrelevant state (e.g. at the end of functions).
-
-   Retain state affected by CHANGE, to make it easier to generate
-   state_change_events.  */
+   irrelevant state (e.g. at the end of functions).  */
 
 program_state
 program_state::prune_for_point (exploded_graph &eg,
 				const program_point &point,
-				state_change *change) const
+				const exploded_node *enode_for_diag) const
 {
   logger * const logger = eg.get_logger ();
   LOG_SCOPE (logger);
